class Public::MedicalReleasesController < Public::BaseController
  before_action :set_account, :set_project, :set_contract_template

  def new
    @medical_release = build_medical_release
  end

  def create
    @medical_release = build_medical_release(medical_release_params_with_locale_and_contract_template)

    if @medical_release.save(context: :native)
      if @medical_release.contract_template.present?
        AttachContractToReleasableJob.perform_later(@medical_release)
      end
    else
      render :new
    end
  end

  private

  def set_project
    @project = @account.projects.find(params[:project_id])
  end

  def set_account
    @account = Account.find_by(slug: params[:account_id])
  end

  def set_contract_template
    @contract_template = @project.contract_templates.find(params[:contract_template_id])
  end

  def medical_releases
    policy_scope(@project.medical_releases)
  end

  def build_medical_release(params = {})
    authorize medical_releases.build(params)
  end

  def medical_release_params
    params
      .require(:medical_release)
      .permit(
        person_params,
        guardian_params,
        second_guardian_params,
        :minor,
        :signature_base64,
        :locale,
        :contract_template,
        :question_1_answer, :question_2_answer,
        :question_3_answer, :question_4_answer,
        :question_5_answer, :question_6_answer,
        :question_7_answer, :question_8_answer,
        :question_9_answer, :question_10_answer,
        :question_11_answer, :question_12_answer,
        :question_13_answer, :question_14_answer,
        :question_15_answer, photos: [],
      )
  end

  def person_params
    %i[
      person_first_name
      person_last_name
      person_phone
      person_email
      person_address_street1
      person_address_street2
      person_address_city
      person_address_state
      person_address_zip
      person_address_country
    ]
  end

  def guardian_params
    %i[
      guardian_first_name
      guardian_last_name
      guardian_phone
      guardian_email
      guardian_photo
      guardian_address_street1
      guardian_address_street2
      guardian_address_city
      guardian_address_state
      guardian_address_zip
      guardian_address_country
    ]
  end

  def second_guardian_params
    %i[
      guardian_2_first_name
      guardian_2_last_name
      guardian_2_phone
      guardian_2_email
      guardian_2_photo
      guardian_2_address_street1
      guardian_2_address_street2
      guardian_2_address_city
      guardian_2_address_state
      guardian_2_address_zip
      guardian_2_address_country
    ]
  end

  def medical_release_params_with_locale
    medical_release_params.merge(locale: I18n.locale)
  end

  def medical_release_params_with_locale_and_contract_template
    medical_release_params_with_locale.merge(contract_template: @contract_template)
  end
end
